require "TimedActions/ISBaseTimedAction"

ISWarmUp = ISBaseTimedAction:derive("ISWarmUp");

function ISWarmUp:isValid()
	return not self.character:isDriving();
end

function ISWarmUp:update()
	if self.character:isCurrentState(IdleState.instance()) or self.character:isSitOnGround() or self.character:isAiming() or self.character:isStrafing() then
		self.character:setMetabolicTarget(self.character:isPlayerMoving() and Metabolics.LightWork or Metabolics.JumpFence);
		self.character:getStats():setEndurance(self.character:getStats():getEndurance() - 0.000035 * getGameTime():getMultiplier());
	end
end

function ISWarmUp:start()
	self.character:setVariable("ExerciseStarted", false);
	self.character:setVariable("ExerciseEnded", true);
	self:setActionAnim("WarmHands")
end

function ISWarmUp:animEvent(event, parameter)
	if event == "Breath" then
		if getGameSpeed() ~= 1 then return end
		if self.character:isFemale() then
			self.sound = self.character:playSound("BreathingWoman")
		else
			self.sound = self.character:playSound("BreathingMan")
		end
    elseif event == "RubHands" then
		addSound(self.character, self.character:getX(), self.character:getY(), self.character:getZ(), 2, 1)
        if getGameSpeed() ~= 1 then return end
		self.sound = self.character:playSound("RubHands")
    end
end

function ISWarmUp:stop()
	if self.sound and self.character:getEmitter():isPlaying(self.sound) then
		self.character:stopOrTriggerSound(self.sound)
	end
    ISBaseTimedAction.stop(self);
end

function ISWarmUp:perform()
	ISBaseTimedAction.perform(self);
end

function ISWarmUp:new(character)
	local o = {}
	setmetatable(o, self)
	self.__index = self
	o.character = character;
	o.stopOnWalk = false
	o.stopOnRun = true
	o.stopOnAim = false

	o.forceProgressBar = true;
	o.maxTime = 1400;

	return o;
end
