
ISWorldObjectContextMenu.onWarmUp = function(player)
    local playerObj = getSpecificPlayer(player)
    local primary = playerObj:getPrimaryHandItem()
    local secondary = playerObj:getSecondaryHandItem()
    if primary and primary:getType() ~= "Tissue" then
        ISTimedActionQueue.add(ISUnequipAction:new(playerObj, primary, 50));
    end
    if secondary and primary ~= secondary and secondary:getType() ~= "Tissue" then
        ISTimedActionQueue.add(ISUnequipAction:new(playerObj, secondary, 50));
    end
    ISTimedActionQueue.add(ISWarmUp:new(playerObj))
end

Events.OnFillWorldObjectContextMenu.Add(function(player, context, worldobjects)

    local playerObj = getSpecificPlayer(player)

    if playerObj:getTemperature() >= 36.6 or (playerObj:getMoodles():getMoodleLevel(MoodleType.Hypothermia) < 1 and playerObj:getBodyDamage():getThermoregulator():getCoreHeatDelta() > 0) or playerObj:isDriving() then return end
    
    local option = context:addOption(getText("ContextMenu_WarmUp"), player, ISWorldObjectContextMenu.onWarmUp);
    
    if playerObj:getBodyDamage():getBodyPart(BodyPartType.Hand_L):HasInjury() or playerObj:getBodyDamage():getBodyPart(BodyPartType.Hand_R):HasInjury() then
        option.notAvailable = true;
        local tooltip = ISWorldObjectContextMenu.addToolTip();
        tooltip.description = getText("ContextMenu_DamagedHands");
        option.toolTip = tooltip;
    end
    
end)